//
//  VerifyURLView.swift
//  SampleApp
//
//  Created by Manuchet Rungraksa on 29/1/2567 BE.
//  Copyright © 2567 BE David Zhang. All rights reserved.
//

import Foundation
import SwiftUI

struct VerifyURLView: View {
    
    enum VerifyMode {
        case whitelist
        case bannedWord
    }
    
    @ObservedObject var viewModel: VerifyURLViewModel
    @State var mode: VerifyMode = .whitelist
    
    var body: some View {
        VStack(alignment: .center) {
            Text("Each URL is separated by \", \" (comma and space)")
                .font(.caption)
            Picker("Member Type", selection: $mode) {
                Text("Whitelist").tag(VerifyMode.whitelist)
                Text("Banned word").tag(VerifyMode.bannedWord)
            }
            .pickerStyle(.segmented)
            TextField("Check whitelist/ban word", text: $viewModel.textString)
                .textFieldStyle(RoundedBorderTextFieldStyle())
                .font(.callout)
            
            
            Button(action: {
                if mode == .whitelist {
                    viewModel.verifyWhitelist()
                } else {
                    viewModel.verifyBannedWord()
                }
            }){
                Text("Check texts")
                    .frame(alignment: .center)
            }.buttonStyle(BorderlessButtonStyle())
            
            Text(viewModel.resultString)
            Spacer()
        }
    }
}

class VerifyURLViewModel: ObservableObject {
    
    var pageTitle: String
    
    @Published var textString: String = ""
    @Published var resultString: String = ""
    
    private var client = AmityManager.shared.client!
    
    @Published var storyTargets: [StoryTargetListModel] = []
    
    init() {
        self.pageTitle = "Verify view"
        self.resultString = "This feature is not available yet"
    }
    
    func verifyWhitelist() {
//        Task { @MainActor in
//            do {
//                let urls = textString.components(separatedBy: ", ")
//                
//                let success = try await client.validateUrls(urls: urls)
//                resultString = "is success: \(success)"
//            }
//            catch {
//                resultString = "Error: \(error.localizedDescription)"
//            }
//        }
    }
    
    func verifyBannedWord() {
//        Task { @MainActor in
//            do {
//                let texts = textString.components(separatedBy: ", ")
//                
//                let success = try await client.validateTexts(texts: texts)
//                resultString = "is success: \(success)"
//            }
//            catch {
//                resultString = "Error: \(error.localizedDescription)"
//            }
//        }
    }
    
}
